-- Copyright 2022 by Todd Hundersmarck (ThundR)
-- All Rights Reserved
THMain = {} local THMain_mt = Class(THMain, THCore) local function runScript() g_thMain = THMain:new("AnimalProduction") if g_thMain then local globalEnv = g_thMain:getGlobalEnv() local modPath = g_thMain.modPath local HusbandrySystem = globalEnv.HusbandrySystem if HusbandrySystem and HusbandrySystem.GAME_LIMIT <= 64 then HusbandrySystem.GAME_LIMIT = 64 g_thMain:displayMsg("Husbandry limit increased to 64") end g_thMain:hookFunction("FillTypeManager", "addFillType", THFillTypeManager) g_thMain:hookFunction("AnimalLoadingTrigger", "showAnimalScreen", THAnimalLoadingTrigger) g_thMain:hookFunction("UnloadTrigger", "registerXMLPaths", THUnloadTrigger, nil, false) g_thMain:hookFunction("UnloadTrigger", "delete", THUnloadTrigger) g_thMain:hookFunction("ProductionPoint", "load", THProductionPoint) g_thMain:hookFunction("AnimalScreenBase", "getMaxNumAnimals", THAnimalScreenBase) source(modPath.."scripts/events/AnimalMoveEvent.lua") source(modPath.."scripts/controllers/AnimalScreenTrailerToProduction.lua") end end function THMain:new(dataKey, mt) mt = Utils.getNoNil(mt, THMain_mt) local newEnv = THCore:new(dataKey, mt) if newEnv then end return newEnv end function THMain:loadAnimalTrigger(trigger, loadFunc, nodeId, target) loadFunc = Utils.getNoNil(loadFunc, trigger.load) if loadFunc(trigger, nodeId) then local triggerData = self:createDataTable(trigger) local targetData = self:getDataTable(target) if targetData then local stationData, station = self:getDataTable(target.target) if stationData then local customEnv = targetData.customEnv trigger.title = station:getName() trigger.isDealer = false trigger.animalTypes = nil trigger.customEnvironment = customEnv triggerData.target = target triggerData.placeable = targetData.placeable triggerData.isProductionTrigger = true end end return true end return false end function THMain:loadSellingStation(station, loadFunc, target, components, xmlFile, key, customEnv, i3dMappings, rootNode, ...) loadFunc = Utils.getNoNil(loadFunc, station.load) local owningPlaceable = target.owningPlaceable if owningPlaceable then local stationData = self:createDataTable(station) customEnv = owningPlaceable.customEnvironment stationData.target = target stationData.customEnv = customEnv stationData.placeable = owningPlaceable end return loadFunc(station, components, xmlFile, key, customEnv, i3dMappings, rootNode, ...) end function THMain:loadUnloadTrigger(trigger, loadFunc, components, xmlFile, key, target, extraAttributes, i3dMappings, ...) loadFunc = Utils.getNoNil(loadFunc, trigger.load) if loadFunc(trigger, components, xmlFile, key, target, extraAttributes, i3dMappings, ...) then local triggerData = self:createDataTable(trigger) local station = trigger:getTarget() local stationData = self:getDataTable(station) if stationData then triggerData.customEnv = stationData.customEnv triggerData.placeable = stationData.placeable local animalTriggerKey = key..".animalTrigger" if xmlFile:hasProperty(animalTriggerKey) then local nodeId = xmlFile:getValue(animalTriggerKey.."#node", nil, components, i3dMappings) if nodeId then local animalTrigger = AnimalLoadingTrigger.new(self.isServer, self.isClient) if self:loadAnimalTrigger(animalTrigger, nil, nodeId, trigger) then triggerData.animalTrigger = animalTrigger else animalTrigger:delete() end end end end return true end return false end THFillTypeManager = {} function THFillTypeManager:hook_addFillType(superFunc, name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudOverlayFilename, baseDirectory, customEnv, ...) local fillTypeInfo = nil local function prependFunc() if type(name) == "string" and type(title) == "string" then fillTypeInfo = self.nameToFillType[name:upper()] end end g_thMain:pcall(prependFunc) local ra,rb,rc,rd,re = superFunc(self, name, title, showOnPriceTable, pricePerLiter, massPerLiter, maxPhysicalSurfaceAngle, hudOverlayFilename, baseDirectory, customEnv, ...) local function appendFunc() if fillTypeInfo then local fillTypeData = g_thMain:getDataTable(fillTypeInfo, true) local modName = g_thMain.modName local mapModName = g_thMain.mapModName local mapIsMod = g_thMain.mapIsMod if (customEnv == modName and not fillTypeData.hasMapTitle) or (mapIsMod and customEnv == mapModName) then local newTitle = g_i18n:convertText(title, customEnv) if newTitle ~= fillTypeInfo.title then fillTypeInfo.title = newTitle self.indexToTitle[fillTypeInfo.index] = fillTypeInfo.title if customEnv == mapModName then fillTypeData.hasMapTitle = true end end end end end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end THAnimalLoadingTrigger = {} function THAnimalLoadingTrigger:hook_showAnimalScreen(superFunc, ...) local AnimalScreenDealerTrailer, dealerTrailerNew, dealerTrailerNewOrig = g_thMain:call("getFunctionData", "AnimalScreenDealerTrailer", "new") local newController = nil local function prependFunc() local triggerData = g_thMain:getDataTable(self) if triggerData and triggerData.isProductionTrigger then newController = THAnimalScreenTrailerToProduction.new(self.loadingVehicle, self) end end g_thMain:pcall(prependFunc) if newController and dealerTrailerNew then AnimalScreenDealerTrailer.new = function(...) return newController end end local ra,rb,rc,rd,re = superFunc(self, ...) if dealerTrailerNew then AnimalScreenDealerTrailer.new = dealerTrailerNewOrig end return ra,rb,rc,rd,re end THUnloadTrigger = {} function THUnloadTrigger.hook_registerXMLPaths(superFunc, schema, basePath, ...) local ra,rb,rc,rd,re = superFunc(schema, basePath, ...) local function appendFunc() schema:register(XMLValueType.NODE_INDEX, basePath..".animalTrigger#node", "Animal trigger node index") end g_thMain:pcall(appendFunc) return ra,rb,rc,rd,re end function THUnloadTrigger:hook_delete(superFunc, ...) local function prependFunc() local triggerData = g_thMain:getDataTable(self) if triggerData and triggerData.animalTrigger then triggerData.animalTrigger:delete() end end g_thMain:pcall(prependFunc) return superFunc(self, ...) end THProductionPoint = {} function THProductionPoint:hook_load(superFunc, components, xmlFile, key, customEnv, i3dMappings, ...) local SellingStation, sellStationLoadFunc, sellStationLoadFuncOrig = g_thMain:call("getFunctionData", "SellingStation", "load") local UnloadTrigger, unloadTriggerLoadFunc, unloadTriggerLoadFuncOrig = g_thMain:call("getFunctionData", "UnloadTrigger", "load") local I18N, convertTextFunc, convertTextFuncOrig = g_thMain:call("getFunctionData", "I18N", "convertText") local owningPlaceable = self.owningPlaceable if convertTextFunc then I18N.convertText = function(pSelf, pText, pCustomEnv, ...) if owningPlaceable then pCustomEnv = Utils.getNoNil(pCustomEnv, owningPlaceable.customEnvironment) end return convertTextFunc(pSelf, pText, pCustomEnv, ...) end end if sellStationLoadFunc then SellingStation.load = function(pSelf, ...) return g_thMain:call("loadSellingStation", pSelf, sellStationLoadFunc, self, ...) end end if unloadTriggerLoadFunc then UnloadTrigger.load = function(pSelf, ...) return g_thMain:call("loadUnloadTrigger", pSelf, unloadTriggerLoadFunc, ...) end end local ra,rb,rc,rd,re = superFunc(self, components, xmlFile, key, customEnv, i3dMappings, ...) if convertTextFunc then I18N.convertText = convertTextFuncOrig end if sellStationLoadFunc then SellingStation.load = sellStationLoadFuncOrig end if unloadTriggerLoadFunc then UnloadTrigger.load = unloadTriggerLoadFuncOrig end return ra,rb,rc,rd,re end THAnimalScreenBase = {} function THAnimalScreenBase:hook_getMaxNumAnimals(superFunc, ...) return 1000 end runScript()