-- Copyright 2022 by Todd Hundersmarck (ThundR)
-- All Rights Reserved
THAnimalScreenTrailerToProduction = {} local THAnimalScreenTrailerToProduction_mt = Class(THAnimalScreenTrailerToProduction, AnimalScreenBase) THAnimalScreenTrailerToProduction.ERROR_CODE_MAPPING = { SOURCE = { [THAnimalMoveEvent.ERROR_CODE.SUCCESS] = {text = "th_shop_apMovedToProduction", isWarning = false}, [THAnimalMoveEvent.ERROR_CODE.NO_PERMISSION] = {text = "th_shop_apNoAccessToProduction", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_SOURCE] = {text = "th_shop_apInvalidTrailer", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_TARGET] = {text = "th_shop_apInvalidProduction", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_CLUSTER] = {text = "th_shop_apInvalidCluster", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.NOT_ENOUGH_SPACE] = {text = "th_shop_apProductionIsFull", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.ANIMAL_NOT_SUPPORTED] = {text = "th_shop_apAnimalNotSupported", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_NUM_ANIMALS] = {text = "th_shop_apInvalidNumAnimals", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_FARM] = {text = "th_shop_apInvalidFarm", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INTERNAL] = {text = "th_shop_apInternalError", isWarning = true}, }, TARGET = { [THAnimalMoveEvent.ERROR_CODE.SUCCESS] = {text = "th_shop_apMovedToTrailer", isWarning = false}, [THAnimalMoveEvent.ERROR_CODE.NO_PERMISSION] = {text = "th_shop_apNoAccessToTrailer", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_SOURCE] = {text = "th_shop_apInvalidProduction", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_TARGET] = {text = "th_shop_apInvalidTrailer", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_CLUSTER] = {text = "th_shop_apInvalidCluster", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.NOT_ENOUGH_SPACE] = {text = "th_shop_apTrailerIsFull", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.ANIMAL_NOT_SUPPORTED] = {text = "th_shop_apAnimalNotSupported", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_NUM_ANIMALS] = {text = "th_shop_apInvalidNumAnimals", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INVALID_FARM] = {text = "th_shop_apInvalidFarm", isWarning = true}, [THAnimalMoveEvent.ERROR_CODE.INTERNAL] = {text = "th_shop_apInternalError", isWarning = true}, } } local function runScript() end function THAnimalScreenTrailerToProduction.new(trailer, trigger, customMt) customMt = Utils.getNoNil(customMt, THAnimalScreenTrailerToProduction_mt) local newEnv = AnimalScreenBase.new(customMt) if newEnv then local triggerData = g_thMain:getDataTable(trigger) if triggerData and triggerData.isProductionTrigger then newEnv.trailer = trailer newEnv.animalTrigger = trigger newEnv.unloadTrigger = triggerData.target newEnv.station = newEnv.unloadTrigger.target local stationData = g_thMain:getDataTable(newEnv.station) newEnv.production = stationData.target newEnv.placeable = triggerData.placeable newEnv.targetTitle = trigger.title return newEnv end end end function THAnimalScreenTrailerToProduction:initSourceItems() local function protectedFunc() local unloadTrigger = self.unloadTrigger local production = self.production self.sourceItems = {} local clusters = self.trailer:getClusters() if clusters ~= nil then for _, cluster in ipairs(clusters) do local subTypeInfo = g_currentMission.animalSystem:getSubTypeByIndex(cluster.subTypeIndex) local fillTypeIndex = subTypeInfo.fillTypeIndex if unloadTrigger:getIsFillTypeSupported(fillTypeIndex) and production:getCapacity(fillTypeIndex) > 0 then local item = AnimalItemStock.new(cluster) table.insert(self.sourceItems, item) end end end end return g_thMain:call(protectedFunc) end function THAnimalScreenTrailerToProduction:getSourceName() local function protectedFunc() local name = self.trailer:getName() local currentAnimalType = self.trailer:getCurrentAnimalType() if not currentAnimalType then return name end local used = self.trailer:getNumOfAnimals() local total = self.trailer:getMaxNumOfAnimals(currentAnimalType) return string.format("%s (%d / %d)", name, used, total) end return g_thMain:call(protectedFunc) end function THAnimalScreenTrailerToProduction:getSourcePrice(itemIndex, numItems) return false, 0,0,0 end function THAnimalScreenTrailerToProduction:getTargetPrice(itemIndex, numItems) return false, 0,0,0 end function THAnimalScreenTrailerToProduction:getSourceMaxNumAnimals(itemIndex) local function protectedFunc() local item = self.sourceItems[itemIndex] return item:getNumAnimals() end return g_thMain:call(protectedFunc) end function THAnimalScreenTrailerToProduction:getSourceActionText() return g_i18n:getText("th_shop_apUnloadAnimals") end function THAnimalScreenTrailerToProduction:getApplySourceConfirmationText(itemIndex, numItems) local function protectedFunc() local text = g_i18n:getText("th_shop_apDoYouWantToUnloadAnimals") local item = self.sourceItems[itemIndex] return string.format(text, numItems, item:getName()) end return g_thMain:call(protectedFunc) end function THAnimalScreenTrailerToProduction:applySource(itemIndex, numItems) local item = self.sourceItems[itemIndex] local trailer = self.trailer local unloadTrigger = self.unloadTrigger local clusterId = item:getClusterId() local farmId = trailer:getOwnerFarmId() local errorCode = THAnimalMoveEvent.validate(trailer, unloadTrigger, clusterId, numItems, nil, farmId) if errorCode then local data = THAnimalScreenTrailerToProduction.ERROR_CODE_MAPPING.SOURCE[errorCode] local errorText = g_i18n:getText(data.text) self.errorCallback(errorText) return false end local actionText = self:getSourceActionText().."?" self.actionTypeCallback(AnimalScreenBase.ACTION_TYPE_SOURCE, actionText) g_messageCenter:subscribe(THAnimalMoveEvent, self.onAnimalMovedToProduction, self) g_client:getServerConnection():sendEvent(THAnimalMoveEvent.new(trailer, unloadTrigger, clusterId, numItems)) return true end function THAnimalScreenTrailerToProduction:onAnimalMovedToProduction(errorCode) g_messageCenter:unsubscribe(THAnimalMoveEvent, self) self.actionTypeCallback(AnimalScreenBase.ACTION_TYPE_NONE, nil) local data = THAnimalScreenTrailerToProduction.ERROR_CODE_MAPPING.SOURCE[errorCode] local errorText = g_i18n:getText(data.text) self.targetActionFinished(data.isWarning, errorText) end function THAnimalScreenTrailerToProduction:onAnimalsChanged(object, clusters) if object == self.trailer then self:initItems() self.animalsChangedCallback() end end runScript()